
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stock_reservationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_reservations = await db.stock_reservations.create(
            {
                id: data.id || undefined,
        
        quantity_reserved: data.quantity_reserved
        ||
        null
            ,
            
        reserved_at: data.reserved_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stock_reservations.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await stock_reservations.setSales_order( data.sales_order || null, {
            transaction,
        });
        
        await stock_reservations.setProduct( data.product || null, {
            transaction,
        });
        
        await stock_reservations.setWarehouse( data.warehouse || null, {
            transaction,
        });
        

        

        

        return stock_reservations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stock_reservationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity_reserved: item.quantity_reserved
            ||
            null
            ,
            
                reserved_at: item.reserved_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stock_reservations = await db.stock_reservations.bulkCreate(stock_reservationsData, { transaction });

        // For each item created, replace relation files
        

        return stock_reservations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const stock_reservations = await db.stock_reservations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity_reserved !== undefined) updatePayload.quantity_reserved = data.quantity_reserved;
        
        
        if (data.reserved_at !== undefined) updatePayload.reserved_at = data.reserved_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await stock_reservations.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await stock_reservations.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.sales_order !== undefined) {
            await stock_reservations.setSales_order(
              
              data.sales_order,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await stock_reservations.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.warehouse !== undefined) {
            await stock_reservations.setWarehouse(
              
              data.warehouse,
              
              { transaction }
            );
        }
        

        
        

        

        return stock_reservations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_reservations = await db.stock_reservations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stock_reservations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stock_reservations) {
                await record.destroy({transaction});
            }
        });


        return stock_reservations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stock_reservations = await db.stock_reservations.findByPk(id, options);

        await stock_reservations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stock_reservations.destroy({
            transaction
        });

        return stock_reservations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stock_reservations = await db.stock_reservations.findOne(
            { where },
            { transaction },
        );

        if (!stock_reservations) {
            return stock_reservations;
        }

        const output = stock_reservations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await stock_reservations.getOrganization({
            transaction
        });
        
        
        output.sales_order = await stock_reservations.getSales_order({
            transaction
        });
        
        
        output.product = await stock_reservations.getProduct({
            transaction
        });
        
        
        output.warehouse = await stock_reservations.getWarehouse({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.sales_orders,
        as: 'sales_order',
        
        where: filter.sales_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sales_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.sales_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.warehouses,
        as: 'warehouse',
        
        where: filter.warehouse ? {
          [Op.or]: [
            { id: { [Op.in]: filter.warehouse.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.warehouse.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.quantity_reservedRange) {
                const [start, end] = filter.quantity_reservedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_reserved: {
                    ...where.quantity_reserved,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_reserved: {
                    ...where.quantity_reserved,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reserved_atRange) {
                const [start, end] = filter.reserved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reserved_at: {
                    ...where.reserved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reserved_at: {
                    ...where.reserved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stock_reservations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stock_reservations',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stock_reservations.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

